// ICON
//
// ---------------------------------------------------------------
// Copyright (C) 2004-2024, DWD, MPI-M, DKRZ, KIT, ETH, MeteoSwiss
// Contact information: icon-model.org
//
// See AUTHORS.TXT for a list of authors
// See LICENSES/ for license information
// SPDX-License-Identifier: BSD-3-Clause
// ---------------------------------------------------------------

#include "support_bindings.h"
#include "mo_lib_loopindices.hpp"
#include "mo_math_utilities.hpp"


// mo_loop_indices.F90
// C wrappers for C++ functionality
void get_indices_c_lib(int i_startidx_in, int i_endidx_in, int nproma, int i_blk, int i_startblk, int i_endblk,
    int &i_startidx_out, int &i_endidx_out){
        get_indices_c_lib(i_startidx_in, i_endidx_in, nproma, i_blk, i_startblk,
                            i_endblk, i_startidx_out, i_endidx_out, false);
}
void get_indices_e_lib(int i_startidx_in, int i_endidx_in, int nproma, int i_blk, int i_startblk, int i_endblk,
    int &i_startidx_out, int &i_endidx_out){
        get_indices_e_lib(i_startidx_in, i_endidx_in, nproma,i_blk, i_startblk, i_endblk,
                            i_startidx_out, i_endidx_out, false);
}

void get_indices_v_lib(int i_startidx_in, int i_endidx_in, int nproma, int i_blk, int i_startblk, int i_endblk,
    int &i_startidx_out, int &i_endidx_out){
        get_indices_v_lib(i_startidx_in, i_endidx_in, nproma, i_blk, i_startblk, i_endblk,
            i_startidx_out,i_endidx_out, false);
}

void tdma_solver_vec_dp(const double* a, const double* b, const double* c, const double* d,
    int slev, int elev, int startidx, int endidx,
    int nrows, int ncols, double* varout){
    
    tdma_solver_vec<double>(a, b, c, d, slev, elev, startidx, endidx, nrows, ncols, varout);

}

void tdma_solver_vec_sp(const float* a, const float* b, const float* c, const float* d,
      int slev, int elev, int startidx, int endidx,
      int nrows, int ncols, float* varout){

    tdma_solver_vec<float>(a, b, c, d, slev, elev, startidx, endidx, nrows, ncols, varout);

}
